package org.kisti.htc.myproxy;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.PrivateKey;
import java.security.cert.X509Certificate;
import java.util.Scanner;

import javax.crypto.BadPaddingException;

import org.globus.gsi.CertUtil;
import org.globus.gsi.GSIConstants;
import org.globus.gsi.GlobusCredential;
import org.globus.gsi.OpenSSLKey;
import org.globus.gsi.X509ExtensionSet;
import org.globus.gsi.bc.BouncyCastleCertProcessingFactory;
import org.globus.gsi.bc.BouncyCastleOpenSSLKey;
import org.globus.gsi.gssapi.GlobusGSSCredentialImpl;
import org.globus.myproxy.MyProxy;
import org.globus.util.Util;
import org.gridforum.jgss.ExtendedGSSManager;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSException;
import org.ietf.jgss.GSSManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class HTCaaS_ProxyInit extends gridPropertiesUtil {

    public MyProxy myproxy;
   
   // private final static String TRUSTED_CERT_PATH = "/.globus/certificates";
    private GlobusCredential gridProxy = null;
    final static Logger logger = LoggerFactory.getLogger(HTCaaS_ProxyInit.class);
    private GSSCredential credential = null;
    
    private static String username;
    private static String password;
    private static String myproxyPassword;
    static Scanner in = new Scanner(System.in);
    
    public HTCaaS_ProxyInit(String un, String pw, String mppw){
    	super();
    	this.username= un;
    	this.password = pw;
    	this.myproxyPassword = mppw;
    	
    }
    
//	public void Init (){
//	     		
//					if (validateUsername() && validatePassword()
//			                  && validateMyproxyPassword()) {
//			              if (createProxy(gridProps.getCredLifetime()))
//			                  sendProxy();
//			          }
//	} // End of Init()
	
	public boolean Init (){
 		
		if (validateUsername() && validatePassword()
                  && validateMyproxyPassword()) {  
              if (createProxy(gridProps.getCredLifetime()))
                 {  return  sendProxy();
			 }else{ return false;
					}
          }else{ return false;
         }
} // End of Init()

	
    private boolean validateUsername() {
			        if (username.trim().equals("")) {
			        	logger.error("no username exists! ");
			            return false;
			        }
			        return true;
   }
			    
    private boolean validatePassword() {
			        if (password.length() == 0) {
			        	logger.error("no password exists! ");
			            return false;
			        }
			        return true;
			    }
			
	private boolean validateMyproxyPassword() {
			        if (myproxyPassword.equals("")) {
			        	logger.error("no myproxy password exists! ");
//			            System.out.print("Input myproxy password: ");
//			            myproxyPassword= in.nextLine();
//				            if (myproxyPassword.equals("")){
//				            return false; }else {return true;}
			        	return false;
			        }else{
			        return true; }
			    }
				
//     public void sendProxy() {
//			
//			        if ((gridProxy == null) || (myproxyPassword.equals("")))
//			            return;
//			
//			        if (myproxyPassword.equals("")) {
//			        	logger.error("no myproxy password exists! ");
//			            System.out.print("Input myproxy password: ");
//			            myproxyPassword= in.nextLine();
//			        }
//			
//			        try {
//			        	myproxy = new MyProxy(gridProps.getMyproxyServer(),gridProps.getMyproxyPort());
//			        	if(gridProxy.getSubject()!= null){
//			        		System.out.println("gridproxy exists!"+gridProxy.getSubject());
//			        		//myproxy.setAuthorization(new IdentityAuthorization(gridProxy.getSubject()));
//			        	}else { credential = getDefaultCredential();}
//			
//			
//			        	myproxy.setAuthorization(new org.globus.gsi.gssapi.auth.IdentityAuthorization("/C=KR/O=KISTI/O=GRID/O=KISTI/CN=host/"+gridProps.getMyproxyServer()));
//						//PUT !!!
//			        	myproxy.put( new GlobusGSSCredentialImpl(gridProxy,
//			                    GSSCredential.INITIATE_AND_ACCEPT), username.trim(), myproxyPassword, gridProps.getCredLifetime());
//						//        	myproxy.put( credential, usernameTF.getText()
//						//                    .trim(), myproxyPassword, gridProps.getCredLifetime());
//			            
//			        	logger.info( "Succesfully delegated a proxy to myproxy server");
//			             System.out.println( "Succesfully delegated a proxy to myproxy server");     
//			        } catch (Exception e) {
//			        	logger.error( "Failed to delegate proxy to myproxy server! \n\" {}", e.getMessage() );
//			        }
//			        return;
//    }
	
	
 //// *****Modified Version *************
     
     public boolean sendProxy() {
			
    	 	boolean result= false;
    	 	
	        if ((gridProxy == null) || (myproxyPassword.equals(""))){
	           result = false;
	        	return result;
	        }
	        if (myproxyPassword.equals("")) {
	        	logger.error("no myproxy password exists! ");
	        	result=false;
	        	return result;
	        }
	
	        try {
	        	myproxy = new MyProxy(gridProps.getMyproxyServer(),gridProps.getMyproxyPort());
	        	if(gridProxy.getSubject()!= null){
	        		logger.info("Grid proxy exists! {}",gridProxy.getSubject());
	        		//myproxy.setAuthorization(new IdentityAuthorization(gridProxy.getSubject()));
	        	}else { credential = getDefaultCredential();}
		
	        	myproxy.setAuthorization(new org.globus.gsi.gssapi.auth.IdentityAuthorization("/C=KR/O=KISTI/O=GRID/O=KISTI/CN=host/"+gridProps.getMyproxyServer()));
				//PUT !!!
	        	myproxy.put( new GlobusGSSCredentialImpl(gridProxy,
	                    GSSCredential.INITIATE_AND_ACCEPT), username.trim(), myproxyPassword, gridProps.getCredLifetime());
				//        	myproxy.put( credential, usernameTF.getText()
				//                    .trim(), myproxyPassword, gridProps.getCredLifetime());
	            
	        	logger.info( "Succesfully delegated a proxy to myproxy server");
	           //  System.out.println( "Succesfully delegated a proxy to myproxy server"); 
	        	result =true;
	        } catch (Exception e) {
	        	logger.error( "Failed to delegate proxy to myproxy server! \n\" {}", e.getMessage() );
	        	result=false;
	        }
	        return result;
}

     
    public boolean createProxy(int hours) {      
        X509Certificate userCert = null;
        PrivateKey userKey = null;
        char[] pwd;
        FileOutputStream out = null;
        try {
            userCert = CertUtil.loadCertificate(gridProps.getUserCertFile());

            if (userCert == null) {
               logger.error("Failed to load cert: {} ", gridProps.getUserCertFile());
                return false;
            }

            pwd = password.toCharArray();

            OpenSSLKey key = new BouncyCastleOpenSSLKey(gridProps
                    .getUserKeyFile());

            if (key.isEncrypted()) {
                key.decrypt(new String(pwd));
            }

            userKey = key.getPrivateKey();

            pwd = null;

            if (userKey == null) {
//                JOptionPane.showMessageDialog(this,
//                        "Failed to load private key: "
//                                + gridProps.getUserKeyFile(), "Error",
//                        JOptionPane.ERROR_MESSAGE);
            	
            	
                return false;
            }

            BouncyCastleCertProcessingFactory factory = 
                BouncyCastleCertProcessingFactory
                .getDefault();

            int proxyType = (gridProps.getLimited()) ? 
                GSIConstants.GSI_4_LIMITED_PROXY
                : GSIConstants.GSI_4_IMPERSONATION_PROXY;

            X509ExtensionSet extSet = null;

            gridProxy = factory.createCredential(
                    new X509Certificate[] { userCert }, userKey, gridProps
                            .getBits(), hours*3600, proxyType, extSet);

            if (gridProxy == null) {
            	logger.error("Failed to create proxy! ");

                return false;
            }
            
            File file = Util.createFile(gridProps.getProxyFile());
            // set read only permissions
            if (!Util.setOwnerAccessOnly(gridProps.getProxyFile())) {

            }
            out = new FileOutputStream(file);
            gridProxy.save(out);

        } catch (BadPaddingException e){
        	System.out.println("You have entered an incorrect password");
        } catch (Exception e) {
            e.printStackTrace();
            logger.info( "Failed to create proxy!\n\" {}", e.getMessage() );
           
            return false;
        } finally {
            if (out != null) {
                try {
                    out.close();
                } catch (IOException e) {
                }
            }
        }
        return true;
    }

    private static GSSCredential getDefaultCredential() {
        GSSManager manager = ExtendedGSSManager.getInstance();
        try {
            return manager.createCredential(GSSCredential.INITIATE_ONLY);
        } catch(GSSException e) {
            System.err.println("Failed to load default credentials: " + 
                               e.getMessage());
            System.exit(-1);
        }
        return null;
    } 
    
    public void setUsername(String un){
    	this.username=un;
    }
    public void setPassword(String pw){
    	this.password=pw;
    }
    public void setMyProxyPassword(String mppw){
    	this.myproxyPassword=mppw;
    }
    
    
	public static void main(String[] args) {
		
		String a="seoyoung";
		String b="sy1357";
		
		HTCaaS_ProxyInit aaa = new HTCaaS_ProxyInit(a,b,b);
		
//		
		aaa.username = "seoyoung";
		aaa.password= "sy1357";
		aaa.myproxyPassword = "sy1357";
		System.out.println(aaa.Init());
		
	}
	
	

}
